/*
 * $Id$
 */

/*
 * Reserved registers.
 */
#define P	%ebp
#define HP	%esi

/*
 * Context switching macros.
 */
#define SWITCH_C_TO_ERLANG_QUICK	\
	movl	%esp, P_CSP(P);	\
	movl	P_NSP(P), %esp

#define SWITCH_ERLANG_TO_C_QUICK	\
	movl	%esp, P_NSP(P);	\
	movl	P_CSP(P), %esp

#define SWITCH_C_TO_ERLANG	\
	movl	P_HP(P), HP;	\
	SWITCH_C_TO_ERLANG_QUICK

#define SWITCH_ERLANG_TO_C	\
	movl	HP, P_HP(P);	\
	SWITCH_ERLANG_TO_C_QUICK

/*
 * Argument (parameter) registers.
 */
#define X86_NR_ARG_REGS	3

#define ARG0	%eax
#define ARG1	%edx
#define ARG2	%ecx

/*
 * Temporary registers in runtime glue code.
 * 1. They are C callee-save.
 * 2. They may alias some general argument registers.
 * 3. TEMP1 DOES NOT alias any native BIF argument register.
 */
#define TEMP0	%ebx
#define TEMP1	%edi


#define LOAD_ARG_REGS	movl P_ARG0(P), ARG0 ; movl P_ARG1(P), ARG1 ; movl P_ARG2(P), ARG2 ; 

#define STORE_ARG_REGS	movl ARG0, P_ARG0(P) ; movl ARG1, P_ARG1(P) ; movl ARG2, P_ARG2(P) ; 


/* #define NBIF_COPY_ESP_0	 */
/* #define NBIF_COPY_ESP_1	 */
/* #define NBIF_COPY_ESP_2	 */
/* #define NBIF_COPY_ESP_3	 */

/* #define NBIF_ARG_1_0	ARG0 */
/* #define NBIF_ARG_2_0	ARG0 */
/* #define NBIF_ARG_2_1	ARG1 */
/* #define NBIF_ARG_3_0	ARG0 */
/* #define NBIF_ARG_3_1	ARG1 */
/* #define NBIF_ARG_3_2	ARG2 */

/* #define NBIF_RET_0	ret	 */
/* #define NBIF_RET_1	ret	 */
/* #define NBIF_RET_2	ret	 */
/* #define NBIF_RET_3	ret	 */

/* #define NBIF_SAVE_RESCHED_ARGS_1 movl ARG0, TEMP0 ;  */
/* #define NBIF_SAVE_RESCHED_ARGS_2 movl ARG0, TEMP0 ; movl ARG1, TEMP1 ;  */

/* #define NBIF_SAVE_CALLER_SAVE	pushl ARG2 ; pushl ARG1 ; pushl ARG0 ;  */
/* #define NBIF_RESTORE_CALLER_SAVE_1	movl 4(%esp), ARG0 ; movl 8(%esp), ARG1 ; movl 12(%esp), ARG2 ; addl $16, %esp */
