# ``The contents of this file are subject to the Erlang Public License,
# Version 1.1, (the "License"); you may not use this file except in
# compliance with the License. You should have received a copy of the
# Erlang Public License along with this software. If not, it can be
# retrieved via the world wide web at http://www.erlang.org/.
# 
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
# the License for the specific language governing rights and limitations
# under the License.
# 
# The Initial Developer of the Original Code is Ericsson Utvecklings AB.
# Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
# AB. All Rights Reserved.''
# 
#     $Id$
#
include $(ERL_TOP)/make/target.mk

ifeq ($(TYPE),debug)
PURIFY =
TYPEMARKER = .debug
TYPE_FLAGS = -g -I/usr/local/src/erlang/otp_src_R9B-1/erts/i686-pc-linux-gnu  -DDEBUG -DINSTRUMENT
else
ifeq ($(TYPE),instr)
PURIFY =
TYPEMARKER = .instr
TYPE_FLAGS = -g -O2 -I/usr/local/src/erlang/otp_src_R9B-1/erts/i686-pc-linux-gnu  -DINSTRUMENT
else
ifeq ($(TYPE),purify)
PURIFY = purify
TYPEMARKER = .purify
TYPE_FLAGS = -g -O2 -I/usr/local/src/erlang/otp_src_R9B-1/erts/i686-pc-linux-gnu  -DPURIFY -DNO_JUMP_TABLE
else
ifeq ($(TYPE),quantify)
PURIFY = quantify
TYPEMARKER = .quantify
TYPE_FLAGS = -g -O2 -I/usr/local/src/erlang/otp_src_R9B-1/erts/i686-pc-linux-gnu  -g -O2 -DQUANTIFY -DNO_JUMP_TABLE
else
PURIFY =
TYPEMARKER =
TYPE_FLAGS = -g -O2 -I/usr/local/src/erlang/otp_src_R9B-1/erts/i686-pc-linux-gnu 
endif
endif
endif
endif

#
#
#
ERLANG_OSTYPE = unix

SHELL   = /bin/sh
CC      = gcc
WFLAGS  = -Wall
CFLAGS  = $(TYPE_FLAGS) -DHAVE_CONFIG_H $(WFLAGS) -DUSE_THREADS -D_REENTRANT -DPOSIX_THREADS -D_THREAD_SAFE
LIBS    = -lcurses -lresolv -ldl -lm  -lpthread -L$(ERL_TOP)/erts/obj/$(TARGET) -lz

EMSRCDIR   = $(ERL_TOP)/erts/emulator/beam
SYSSRCDIR  = $(ERL_TOP)/erts/emulator/sys/$(ERLANG_OSTYPE)
CONF_H_DIR = $(ERL_TOP)/erts/$(TARGET)
OBJDIR     = $(ERL_TOP)/erts/obj$(TYPEMARKER).beam/$(TARGET)



